"{ Encoding: utf8 }"

"{ Package: 'stx:goodies/regression' }"

"{ NameSpace: RegressionTests }"

TestCase subclass:#CRCTests
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'tests-Regression-Files and Encodings'
!

!CRCTests class methodsFor:'documentation'!

documentation
"
    documentation to be added.

    [author:]
        Claus Gittinger

    [instance variables:]

    [class variables:]

    [see also:]

"
! !

!CRCTests methodsFor:'tests'!

test01_crc32
    "the default ccitt crc32"
    
    CRC32Stream flushCrcTables.

    self assert:(CRC32Stream new hashValueOf:'') = 0.
    self assert:(CRC32Stream new hashValueOf:'a') = 16rE8B7BE43.
    self assert:(CRC32Stream new hashValueOf:'resume') = 16r60C1D0A0.
    self assert:(CRC32Stream new hashValueOf:#[1 2 3 4 5 6 7]) = 16r70E46888.
    self assert:(CRC32Stream new hashValueOf:(ByteArray new:40 withAll:16rFF)) = 16r8CD04C73.
    self assert:(CRC32Stream new hashValueOf:'123456789') = 16rCBF43926.
    self assert:(CRC32Stream new hashValueOf:'Lammert Bies') = 16r43C04CA6.
    self assert:(CRC32Stream new hashValueOf:' ') = 16rE96CCF45.

    "Created: / 16-03-2019 / 23:22:34 / Claus Gittinger"
    "Modified (comment): / 17-03-2019 / 14:08:26 / Claus Gittinger"
!

test02_crc32c
    "the Castagnoli crc32"
    
    CRC32Stream flushCrcTables.

    self assert:(CRC32Stream newCrc32c hashValueOf:'') = 0.
    self assert:(CRC32Stream newCrc32c hashValueOf:'a') = 16rC1D04330.
    self assert:(CRC32Stream newCrc32c hashValueOf:'123456789') = 16rE3069283.
    self assert:(CRC32Stream newCrc32c hashValueOf:(ByteArray new:32 withAll:0)) = 16r8A9136AA.
    self assert:(CRC32Stream newCrc32c hashValueOf:(ByteArray new:32 withAll:16rFF)) = 16r62a8ab43.
    self assert:(CRC32Stream newCrc32c hashValueOf:((0 to:31) asByteArray)) = 16r46dd794e.
    self assert:(CRC32Stream newCrc32c hashValueOf:(ByteArray new:1000000)) = 16r71AF9A4E.

    "Created: / 16-03-2019 / 23:39:52 / Claus Gittinger"
    "Modified: / 17-03-2019 / 16:56:14 / Claus Gittinger"
!

test03_crc16
    "the crc16 variants"

    self skipIf:true description:'fails, by order of cg - skip'.

    "/ 1..9 testVector from 
    "/    https://www.lammertbies.nl/comm/info/crc-calculation.html

    CRC16Stream flushCrcTables.
    "/ CRCStream flushCrcTables.
    "/ CRC32Stream flushCrcTables.
    self assert:(CRC16Stream newKERMIT hashValueOf:'') = 0.
    self assert:(CRC16Stream newKERMIT hashValueOf:'a') = 16r8F72.
    self assert:(CRC16Stream newKERMIT hashValueOf:'abc') = 16rE958.
    self assert:(CRC16Stream newKERMIT hashValueOf:' ') = 16r0221.
    self assert:(CRC16Stream newKERMIT hashValueOf:'123456789') = 16r8921.
    self assert:(CRC16Stream newKERMIT hashValueOf:'Lammert Bies') = 16rF80D.
    self assert:(CRC16Stream newKERMIT hashValueOf:#[16r06 16r00 16r0c 16rf0 16r00 16r04 16r00 16r55 16r88 16r73 16rc9 16r00 16r00 16r05 16r21]
                                                    ) = 16r2098.

    self assert:(CRC16Stream newDNP hashValueOf:'') = 16rFFFF.
    self assert:(CRC16Stream newDNP hashValueOf:'a') = 16r50B3.
    self assert:(CRC16Stream newDNP hashValueOf:'abc') = 16r57E9.
    self assert:(CRC16Stream newDNP hashValueOf:' ') = 16r50D6.
    self assert:(CRC16Stream newDNP hashValueOf:'123456789') = 16r82EA.
    self assert:(CRC16Stream newDNP hashValueOf:'Lammert Bies') = 16r4583.
    self assert:(CRC16Stream newDNP hashValueOf:#[16r06 16r00 16r0c 16rf0 16r00 16r04 16r00 16r55 16r88 16r73 16rc9 16r00 16r00 16r05 16r21]) = 16r7482.

    self assert:(CRC16Stream newMODBUS hashValueOf:'') = 16rFFFF.
    self assert:(CRC16Stream newMODBUS hashValueOf:'a') = 16rA87E.
    self assert:(CRC16Stream newMODBUS hashValueOf:'abc') = 16r5749.
    self assert:(CRC16Stream newMODBUS hashValueOf:' ') = 16r98BE.
    self assert:(CRC16Stream newMODBUS hashValueOf:'123456789') = 16r4B37.
    self assert:(CRC16Stream newMODBUS hashValueOf:'Lammert Bies') = 16rB45C.
    self assert:(CRC16Stream newMODBUS hashValueOf:#[16r06 16r00 16r0c 16rf0 16r00 16r04 16r00 16r55 16r88 16r73 16rc9 16r00 16r00 16r05 16r21]
                                                    ) = 16rF50C.

    self assert:(CRC16Stream newXMODEM hashValueOf:'') = 0.
    self assert:(CRC16Stream newXMODEM hashValueOf:'a') = 16r7C87.
    self assert:(CRC16Stream newXMODEM hashValueOf:'abc') = 16r9dd6.
    self assert:(CRC16Stream newXMODEM hashValueOf:' ') = 16r2462.
    self assert:(CRC16Stream newXMODEM hashValueOf:'123456789') = 16r31C3.
    self assert:(CRC16Stream newXMODEM hashValueOf:'Lammert Bies') = 16rCEC8.
    self assert:(CRC16Stream newXMODEM hashValueOf:#[16r06 16r00 16r0c 16rf0 16r00 16r04 16r00 16r55 16r88 16r73 16rc9 16r00 16r00 16r05 16r21]) = 16r3B38.

    self assert:(CRC16Stream newCRC_16 hashValueOf:'') = 0.
    self assert:(CRC16Stream newCRC_16 hashValueOf:'a') = 16rE8C1.
    self assert:(CRC16Stream newCRC_16 hashValueOf:'abc') = 16r9738.
    self assert:(CRC16Stream newCRC_16 hashValueOf:' ') = 16rD801.
    self assert:(CRC16Stream newCRC_16 hashValueOf:'123456789') = 16rBB3D.
    self assert:(CRC16Stream newCRC_16 hashValueOf:'Lammert Bies') = 16rB638.
    self assert:(CRC16Stream newCRC_16 hashValueOf:#[16r06 16r00 16r0c 16rf0 16r00 16r04 16r00 16r55 16r88 16r73 16rc9 16r00 16r00 16r05 16r21]) = 16r4A4C.

    "/ CCITT with 0xFFFF as start
    self assert:(CRC16Stream newCCITT hashValueOf:'') = 16rFFFF.
    self assert:(CRC16Stream newCCITT hashValueOf:'a') = 16r9D77.
    self assert:(CRC16Stream newCCITT hashValueOf:'abc') = 16r514A.
    self assert:(CRC16Stream newCCITT hashValueOf:' ') = 16rC592.
    self assert:(CRC16Stream newCCITT hashValueOf:'123456789') = 16r29B1.
    self assert:(CRC16Stream newCCITT hashValueOf:'Lammert Bies') = 16r4A31.
    self assert:(CRC16Stream newCCITT hashValueOf:#[16r06 16r00 16r0c 16rf0 16r00 16r04 16r00 16r55 16r88 16r73 16rc9 16r00 16r00 16r05 16r21]
                                                   ) = 16r75FB.

    "/ CCITT with 0x1D0F as start
    self assert:(CRC16Stream newCCITT_1D0F hashValueOf:'') = 16r1D0F.
    self assert:(CRC16Stream newCCITT_1D0F hashValueOf:'a') = 16rB01B.
    self assert:(CRC16Stream newCCITT_1D0F hashValueOf:'abc') = 16r8CDA.
    self assert:(CRC16Stream newCCITT_1D0F hashValueOf:' ') = 16rE8FE.
    self assert:(CRC16Stream newCCITT_1D0F hashValueOf:'123456789') = 16rE5CC.
    self assert:(CRC16Stream newCCITT_1D0F hashValueOf:'Lammert Bies') = 16r67A2.
    self assert:(CRC16Stream newCCITT_1D0F hashValueOf:#[16r06 16r00 16r0c 16rf0 16r00 16r04 16r00 16r55 16r88 16r73 16rc9 16r00 16r00 16r05 16r21]) = 16rFCD4.

    "Created: / 16-03-2019 / 23:40:26 / Claus Gittinger"
    "Modified: / 19-03-2019 / 11:23:27 / Stefan Reise"
    "Modified (format): / 24-03-2019 / 21:03:06 / Claus Gittinger"
!

test04_crc8
    "the crc8 variants"

    self skipIf:true description:'fails, by order of cg - skip'.

    CRC8Stream flushCrcTables.

    "/ test vectors from AUTOSAR_SWS_CRCLibrary.pdf
    self assert:(CRC8Stream newSAE_J1850 hashValueOf:'') = 0.
    self assert:(CRC8Stream newSAE_J1850 hashValueOf:#[0 0 0 0] ) = 16r59.
    self assert:(CRC8Stream newSAE_J1850 hashValueOf:#[16rF2 16r01 16r83]) = 16r37.
    self assert:(CRC8Stream newSAE_J1850 hashValueOf:#[16r0F 16rAA 16r99 16r55]) = 16r79.
    self assert:(CRC8Stream newSAE_J1850 hashValueOf:#[16r00 16rFF 16r55 16r11]) = 16rB8.
    self assert:(CRC8Stream newSAE_J1850 hashValueOf:#[16r33 16r22 16r55 16rAA 16rBB 16rCC 16rDD 16rEE 16rFF]) = 16rCB.
    self assert:(CRC8Stream newSAE_J1850 hashValueOf:#[16r92 16r6B 16r55]) = 16r8C.
    self assert:(CRC8Stream newSAE_J1850 hashValueOf:#[16rFF 16rFF 16rFF 16rFF]) = 16r74.

    "/ test vectors from AUTOSAR_SWS_CRCLibrary.pdf
    "/ self assert:(CRC8Stream new_2F hashValueOf:'') = 0.
    self assert:(CRC8Stream new_2F hashValueOf:#[0 0 0 0] ) = 16r12.
    self assert:(CRC8Stream new_2F hashValueOf:#[16rF2 16r01 16r83]) = 16rC2.
    self assert:(CRC8Stream new_2F hashValueOf:#[16r0F 16rAA 16r99 16r55]) = 16rC6.
    self assert:(CRC8Stream new_2F hashValueOf:#[16r00 16rFF 16r55 16r11]) = 16r77.
    self assert:(CRC8Stream new_2F hashValueOf:#[16r33 16r22 16r55 16rAA 16rBB 16rCC 16rDD 16rEE 16rFF]) = 16r11.
    self assert:(CRC8Stream new_2F hashValueOf:#[16r92 16r6B 16r55]) = 16r33.
    self assert:(CRC8Stream new_2F hashValueOf:#[16rFF 16rFF 16rFF 16rFF]) = 16r6C.

    "Created: / 24-03-2019 / 12:03:54 / Claus Gittinger"
    "Modified: / 25-03-2019 / 14:25:02 / Claus Gittinger"
!

test99_speed
    |oneTest speedTest|

    self skipIf:true description:'speedtest; not part of automated test suite'.

    oneTest := [:name :hashStream :n :s |
        |l t nMb|

        l := s size.
        t := Time millisecondsToRun:[
                n timesRepeat:[
                        hashStream nextPutAll:s
                ].
             ].
        t := (t / 1000) asFloat.
        nMb := n*l/1024/1024.
        Transcript showCR:'%1: %2 (chunk size %3)' with:name with:(hashStream hashValue hexPrintString) with:l.
        Transcript showCR:'  %1 seconds for %2 Mb' with:t with:(nMb asFixedPoint:2).
        Transcript showCR:'  %1 Mb/s' with:((nMb / t) asFixedPoint:2).
    ].

    speedTest := [:name :hashStreamMaker |
        Transcript showCR:'-----------------------'.
        oneTest 
            value:name value:(hashStreamMaker value) value:2000000
            value:'1234567890'.
        oneTest
            value:name value:(hashStreamMaker value) value:2000000
            value:'12345678901234567890123456789012345678901234567890'.
        oneTest
            value:name value:(hashStreamMaker value) value:200000
            value:('12345678901234567890123456789012345678901234567890' ,* 20).
        oneTest
            value:name value:(hashStreamMaker value) value:20000
            value:('12345678901234567890123456789012345678901234567890' ,* 1000).
    ].

    speedTest 
        value:'crc32' value:[CRC32Stream new].
    speedTest 
        value:'crc32 castagnoli' value:[CRC32Stream newCastagnoli].

    "Created: / 23-03-2019 / 09:53:58 / Claus Gittinger"
    "Modified: / 23-03-2019 / 14:41:14 / Claus Gittinger"
! !

!CRCTests class methodsFor:'documentation'!

version_CVS
    ^ '$Header$'
! !

